/**
 * Created with JetBrains PhpStorm.
 * User: kiragaz
 * Date: 11/14/12
 * Time: 12:49 PM
 * To change this template use File | Settings | File Templates.
 */

jQuery(document).ready(function ($) {

	function getFxsTableDataPrepaired() {

		var fxsDataRaw = values.chanbank.BODY,
		  fxsData = [];

		$(fxsDataRaw).each(function (index, oneRow) {

			var dataRow = {},
			  comment = $.type( oneRow.desc ) == 'undefined' ? '' : oneRow.desc,
			  model = $.type( oneRow.model ) == 'undefined' ? '' : oneRow.model,
			  mac = $.type( oneRow.mac ) == 'undefined' ? '' : oneRow.mac,
			  address = $.type( oneRow.address ) == 'undefined' ? '' : oneRow.address,
			  ports = $.type( oneRow.ports ) == 'undefined' ? 0 : oneRow.ports;

			dataRow.comment = comment;
			dataRow.model = model;
			dataRow.mac = mac;

			for ( var i = 1; i <= 24; i++ ) {
				if ( i <= ports ) {
					var extention = $.type( oneRow["port" + i] ) == 'undefined' ? '' : oneRow["port" + i];

					dataRow["port" + i] = extention;
				} else {
					dataRow["port" + i] = '';
				}
			}

			dataRow.address = address;
			dataRow.ports = ports;

			fxsData.push( dataRow );
		});
		return fxsData;
	}


	var fxsTable = $('#fxsTable').DataTable( {
		select: true,
		paging: true,
		pageLength: 25,
		searching: true,
		autoWidth: false,
		order: [[ 1, 'asc' ]],
		ajax: function ajax(data, callback, settings){
			callback({
				data: getFxsTableDataPrepaired()
			});
		},
		columns: [ // column header
			{"data":"comment", "title": translation['devices.Comment'], 'width': '150px', "orderable": true},
			{"data":"model", "title": translation['devices.Model'], "orderable": true},
			{"data":"mac", "title": translation['devices.MACAddress'], width: "100px", className: "center", "orderable": true},
			{"data":"address", "title": 'address', "orderable": false, "visible": false},
			{"data":"ports", "title": 'ports', "orderable": false, "visible": false},

			{"data":"port1", "title": '1', "orderable": false},
			{"data":"port2", "title": '2', "orderable": false},
			{"data":"port3", "title": '3', "orderable": false},
			{"data":"port4", "title": '4', "orderable": false},
			{"data":"port5", "title": '5', "orderable": false},
			{"data":"port6", "title": '6', "orderable": false},
			{"data":"port7", "title": '7', "orderable": false},
			{"data":"port8", "title": '8', "orderable": false},
			{"data":"port9", "title": '9', "orderable": false},
			{"data":"port10", "title": '10', "orderable": false},
			{"data":"port11", "title": '11', "orderable": false},
			{"data":"port12", "title": '12', "orderable": false},
			{"data":"port13", "title": '13', "orderable": false},
			{"data":"port14", "title": '14', "orderable": false},
			{"data":"port15", "title": '15', "orderable": false},
			{"data":"port16", "title": '16', "orderable": false},
			{"data":"port17", "title": '17', "orderable": false},
			{"data":"port18", "title": '18', "orderable": false},
			{"data":"port19", "title": '19', "orderable": false},
			{"data":"port20", "title": '20', "orderable": false},
			{"data":"port21", "title": '21', "orderable": false},
			{"data":"port22", "title": '22', "orderable": false},
			{"data":"port23", "title": '23', "orderable": false},
			{"data":"port24", "title": '24', "orderable": false}
		],
		data: getFxsTableDataPrepaired(),
		language: dataTableLanguage,
		deferRender: true,
		dom: '<"dataTables_top"f>t<"dataTables_bottom"ip<"dataTables_buttons">l<"clear">>'
	  }).on('click', 'tbody tr', function (e){
			var selectedData = fxsTable.rows({selected: true}).data()
			if (selectedData.length ) {
				$('#editFXS').button('enable');
			} else {
				$('#editFXS').button('disable');
			}
	  }).on('dblclick', 'tbody tr', function(e){
		    var tr = $(event.target);

			if(tr.hasClass('selected')){
				fxsTable.rows(tr).deselect();
			}else{
				fxsTable.rows(tr).select();
			}

			$('#editFXS').button('enable');
			$('#fxsDialog').dialog('open');
	  });

	$("#editFXS").button({icons:{primary:'ui-icon-pencil', secondary:'ui-icon-newwin'}, disabled:true} ).on("click", function () {
		$('#fxsDialog').dialog('open');
	});


	function fxsDialogOpen() {
		var selectedData = fxsTable.rows({selected: true}).data()
		  $this = $( this ),
		  html = '<table style="width:100%"><tr><td width="90px">'+translation['devices.Comment']+':</td><td><input id="fxsDialog_comment" type="text" value="'+ selectedData[0].comment +'"class="ui-combobox-input ui-autocomplete-input ui-widget ui-widget-content ui-corner-all ui-state-default ui-dialog-input" /></td></tr>',
		  portsCount = selectedData[0].ports,
		  address = selectedData[0].address,
		  mac = selectedData[0].mac;

		var getPhone = [];
		var extention = '';

		for ( var i = 0; i < portsCount; i++ ) {
			var portKey = 'port' + (i + 1);
			extention = $.type( selectedData[0][portKey]) == 'undefined' ? '' : selectedData[0][portKey];
			if(extention != ''){
				getPhone[i+1] = extention;
			}

			html += '<tr><td>'+translation['strings.Port']+' ' + (i + 1) + ':</td><td class="saveUserData"><input type="text" id="fxsDialog_port'+ (i + 1) +'" class="autoLoadUser ui-combobox-input ui-autocomplete-input ui-widget ui-widget-content ui-corner-all ui-state-default ui-dialog-input" style="width:184px" value="'+(extention?extention:'Unknown')+'"><span class="resLoadUser" style="font-size:11px; color:#666; padding-left:5px;">&nbsp;&nbsp;</span></td></tr>';
		}

		if(getPhone.length){
			$.ajax({
		          url: "devices/index.php?action=getUsersByPhone",
		          dataType: "json",
		          data: {
		            phone: getPhone
		          },
		          success: function( data ) {
		        	  if(data){
		        		  for ( var i = 0; i < portsCount; i++ ) {
		  	        		if(getPhone[i+1] && data[getPhone[i+1]]){
		  	        			$( '#fxsDialog_port' + ( i + 1 ) ).val(data[getPhone[i+1]]);
		  	        		}
		        		  }
		        	  }
		          }.bind(this)
		    });
		}

		html += '</table>';
		html += '<input type="hidden" id="fxsDialog_address"  value="'+ address +'" />';
		html += '<input type="hidden" id="fxsDialog_desc" value="' + mac + '" />';
		html += '<input type="hidden" id="fxsDialog_ports" value="' + portsCount +'" />';
		$this.html( html )
		$this.find( '.autoLoadUser' ).blur(function(e){
			if($(e.target).val() == ''){
				$(e.target).val('Unknown');
            }
		})

		$this.find( '.autoLoadUser' ).focus(function(e){
			if($(e.target).val() == 'Unknown'){
				$(e.target).val('');
            }
			$(e.target).autocomplete('search',$(e.target).val());
		})

		var count = '';
		$this.find( '.autoLoadUser' ).autocomplete({
		      source: function( request, response ) {

		    	var el = this.element;
		    	el.css('border-color', '#d3d3d3');
		    	var elParent = el.parent();
		    	el.val(el.val().replace(/<|>|#|\*|%|\[|\(|;/g, ''));
		    	request.term = el.val();

		        $.ajax({
		          url: "devices/index.php?action=getUsersList",
		          dataType: "json",
		          data: {
		            text: request.term
		          },
		          success: function( data ) {
		        	  elParent.find(".resLoadUser").html('');
		          	if(data['count']){
		          		count = data['count'];
			          	delete data['count'];
		          	}else {
		          		count = '';
		          	}

		          	var users = [{
	        			label: 'Unknown',
	        			value: 'unknown'
	        		}];
		          	if(data != ''){
			        	$.each(data, function(key, item){
			        		users.push({
			        			label: item,
			        			value: key
			        		});
			        	});
		        	}
		          	response(users);
		          }.bind(this)
		        });
		      },
		      minLength: 0,
		      change: function( event, ui){
		    	  if(ui.item){
		    		  $(this).attr('extension', ui.item.value);
		    	  }else{
		    		  $(this).attr('extension', $(this).val());
		    	  }
		    	  $(this).parents('.ui-dialog').find('button').eq(0).focus();
		      },
		      select: function( event, ui) {
		    	  $(this).val(ui.item.label);
		    	  return false;
		      },
		      open: function() {
		    	  $(this).removeClass("ui-corner-all").addClass("ui-corner-top");
		    	  $(this).parent().find(".resLoadUser").html(count);
		      },
		      close: function() {
		    	  $(this).parent().find(".resLoadUser").html('');
		    	  $(this).removeClass("ui-corner-top").addClass("ui-corner-all");
		      },
		      delay: 500
		  });
	}


	function fxsDialogSave() {

		var dataPrepared = {};

		dataPrepared.desc = $( '#fxsDialog_comment' ).val();
		dataPrepared.address = $( '#fxsDialog_address' ).val();
		dataPrepared.mac = $( '#fxsDialog_desc' ).val();
		dataPrepared.ports = $( '#fxsDialog_ports' ).val();

		var dataInput = {};

		for (var i = 0; i < dataPrepared.ports; i++) {
			var port = $('#fxsDialog_port' + (i + 1));
			if(port && port.attr('extension') && port.attr('extension') != ''){
				dataInput[ i + 1 ] = port.attr('extension');
			}else{
				dataInput[ i + 1 ] = parseInt($('#fxsDialog_port' + (i + 1)).val());
			}
		}

		$.ajax({
	          url: "devices/index.php?action=getUsersByPhone",
	          dataType: "json",
	          data: {
	            phone: dataInput
	          },
	          success: function( data ) {
        		  var err = false;
        		  for ( var i = 0; i < dataPrepared.ports; i++ ) {
  	        		if(data && data[dataInput[ i + 1 ]]){
  	        			dataPrepared[ "port" + ( i + 1 ) ] = dataInput[ i + 1 ];
  	        		}
  	        		else{
  	        			dataPrepared[ "port" + ( i + 1 ) ] = 'unknown';
  	        			var vI = $( '#fxsDialog_port' + ( i + 1 ) ).val();
  	        			if(vI && vI!='Unknown'){
  	        				$( '#fxsDialog_port' + ( i + 1 ) ).css('border-color', 'red');
  	        				err = true;
  	        			}
  	        		}
        		  }
        		  if( ! err){
        			  $( this ).dialog( "close" );
        			  $.post( 'devices/index.php', {"action":'setFxsUsers', 'settings':JSON.stringify( dataPrepared )}, function () {
    	      			$( document ).trigger('devicesTable/update');
    	      		  });
        		  }
        		  ap_showWaitMessage('waitDiv', 0);


	          }.bind(this)
	    });
	}

	var fxsUpdate = function () {
		var lastSelected = fxsTable.rows({selected: true}).data();
		fxsTable.ajax.reload(function(){
			if(lastSelected.length > 0){
				// set selected
				fxsTable.rows(function(index, row, node){
					if(row.mac){
						var result = $.grep(lastSelected, function(val){
							return row.mac == val.mac;
						});
						return result.length > 0;
					}
					return false;
				}).select();
			}

			if (lastSelected.length ) {
				$('#editFXS').button('enable');
			} else {
				$('#editFXS').button('disable');
			}

		}, false);
	};

	$(document ).on('fxsTable/update', fxsUpdate);

	var fxsDialogButtons = {};

	fxsDialogButtons[translation['buttons.Save']] = fxsDialogSave;
	fxsDialogButtons[translation['buttons.Cancel']] = function () {
		$( this ).dialog( "close" );
	}

	$("#fxsDialog").dialog( {
		height:280,
		width:350,
		modal:true,
		resizable:false,
		autoOpen:false,
		open: fxsDialogOpen,
		buttons:fxsDialogButtons
	});

});